//--------------------------------------------------------------
// File     : main.c
// Datum    : 20.03.2014
// Version  : 1.1
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F4
// IDE      : CooCox CoIDE 1.7.4
// GCC      : 4.7 2012q4
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : Demo der WS2812-Library
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
//--------------------------------------------------------------

#include "main.h"
#include "stm32_ub_ws2812.h"

void Delay(volatile uint32_t nCount)
{
  while(nCount--)
  {
  }
}


int main(void)
{
  WS2812_HSV_t led1,led2,led3,led4,led5;

  SystemInit(); // Quarz Einstellungen aktivieren

  // init einer WS2812-Kette an PC6 (5 LEDs)
  UB_WS2812_Init();

  led1=WS2812_HSV_COL_RED;    // LED-1 auf "rot"
  led2=WS2812_HSV_COL_YELLOW; // LED-2 auf "gelb"
  led3=WS2812_HSV_COL_GREEN;  // LED-3 auf "gruen"
  led4=WS2812_HSV_COL_CYAN;   // LED-4 auf "cyan"
  led5=WS2812_HSV_COL_BLUE;   // LED-5 auf "blau"

  // Farbwerte setzen
  UB_WS2812_One_Led_HSV(0,led1,0);
  UB_WS2812_One_Led_HSV(1,led2,0);
  UB_WS2812_One_Led_HSV(2,led3,0);
  UB_WS2812_One_Led_HSV(3,led4,0);
  UB_WS2812_One_Led_HSV(4,led5,1);  // mit Refresh

  while(1)
  {
	// kleine pause
    Delay(50000);

    // Farbe von allen Leds aendern
    led1.h++; if(led1.h>359) led1.h=0;
    led2.h++; if(led2.h>359) led2.h=0;
    led3.h++; if(led3.h>359) led3.h=0;
    led4.h++; if(led4.h>359) led4.h=0;
    led5.h++; if(led5.h>359) led5.h=0;

    // neue Farbwerte setzen
    UB_WS2812_One_Led_HSV(0,led1,0);
    UB_WS2812_One_Led_HSV(1,led2,0);
    UB_WS2812_One_Led_HSV(2,led3,0);
    UB_WS2812_One_Led_HSV(3,led4,0);
    UB_WS2812_One_Led_HSV(4,led5,1);  // mit Refresh
  }
}

